from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, File, Int

Gtftk_Retrieve_V0_1_0 = CommandToolBuilder(tool="gtftk_retrieve", base_command=["gtftk", "retrieve"], inputs=[ToolInput(tag="in_species_name", input_type=Boolean(optional=True), prefix="--species-name", doc=InputDocumentation(doc="The species name. (default: homo_sapiens)")), ToolInput(tag="in_output_file", input_type=File(optional=True), prefix="--outputfile", doc=InputDocumentation(doc="Output file (gtf.gz). (default: None)")), ToolInput(tag="in_ensembl_collection", input_type=Boolean(optional=True), prefix="--ensembl-collection", doc=InputDocumentation(doc="Which ensembl collection to interrogate('vertebrate', 'protists', 'fungi', 'plants', 'metazoa'). (default: vertebrate)")), ToolInput(tag="in_release", input_type=Boolean(optional=True), prefix="--release", doc=InputDocumentation(doc="Release number. By default, the latest. (default: None)")), ToolInput(tag="in_list_only", input_type=Boolean(optional=True), prefix="--list-only", doc=InputDocumentation(doc="If selected, list available species. (default: False)")), ToolInput(tag="in_hide_species_name", input_type=Boolean(optional=True), prefix="--hide-species-name", doc=InputDocumentation(doc="If selected, hide species names upon listing. (default: False)")), ToolInput(tag="in_to_stdout", input_type=Boolean(optional=True), prefix="--to-stdout", doc=InputDocumentation(doc="This option specifies that output will go to the standard output stream, leaving downloaded files intact (or not, see -d). (default: False)")), ToolInput(tag="in_delete", input_type=Boolean(optional=True), prefix="--delete", doc=InputDocumentation(doc="Delete the gtf file after processing (e.g if -c is used). (default: False)")), ToolInput(tag="in_verbosity", input_type=Boolean(optional=True), prefix="--verbosity", doc=InputDocumentation(doc="Set output verbosity ([0-3]). (default: 0)")), ToolInput(tag="in_no_date", input_type=File(optional=True), prefix="--no-date", doc=InputDocumentation(doc="Do not add date to output file names. (default: False)")), ToolInput(tag="in_add_chr", input_type=Boolean(optional=True), prefix="--add-chr", doc=InputDocumentation(doc="Add 'chr' to chromosome names before printing output. (default: False)")), ToolInput(tag="in_tmp_dir", input_type=Boolean(optional=True), prefix="--tmp-dir", doc=InputDocumentation(doc="Keep all temporary files into this folder. (default: None)")), ToolInput(tag="in_keep_all", input_type=Boolean(optional=True), prefix="--keep-all", doc=InputDocumentation(doc="Try to keep all temporary files even if process does not terminate normally. (default: False)")), ToolInput(tag="in_logger_file", input_type=Boolean(optional=True), prefix="--logger-file", doc=InputDocumentation(doc="Stores the arguments passed to the command into a file. (default: None)")), ToolInput(tag="in_write_message_to_file", input_type=Boolean(optional=True), prefix="--write-message-to-file", doc=InputDocumentation(doc="Store all message into a file. (default: None)")), ToolInput(tag="in_arguments", input_type=Int(), position=0, doc=InputDocumentation(doc="Arguments:"))], outputs=[ToolOutput(tag="out_output_file", output_type=File(optional=True), selector=InputSelector(input_to_select="in_output_file", type_hint=File()), doc=OutputDocumentation(doc="Output file (gtf.gz). (default: None)")), ToolOutput(tag="out_no_date", output_type=File(optional=True), selector=InputSelector(input_to_select="in_no_date", type_hint=File()), doc=OutputDocumentation(doc="Do not add date to output file names. (default: False)"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Gtftk_Retrieve_V0_1_0().translate("wdl", allow_empty_container=True)

